--------------------------------------------------------------    
--  Subject : heap, queue, collection
--  Copyright (c) 1999 by A.Baranovsky
--------------------------------------------------------------
  class Heap : array
    function InitHeap( N ) constructor 
    function Push( Key )
    function Restore( F, L ) 
    function Pop( var Key ) 
    function Sort() 
    function ReBuild() 
    function Print() 
    function Empty() 
    function GetCount()
  end

  class Queue     
    function Push( X )
    function Pop( var X )
    function Empty()
    function GetCount()
  end

  class Collection : array  
    function InitColl() constructor
    function "+"( X, Y )
    function App( X )
    function AppColl( iColl ) 
    function Print() 
    function GetCount() 
  end

  implementation Heap
    local A, Count

    function InitHeap( N ) 
      array.Init( N )
      Count := 0
      A == Self()
    return 0

    function Push( Key )
      Inc( Count )
      J := Count

      repeat
        I := J / 2
        if ( I = 0 ) or ( not ( A[ I ] < Key ) ) then
          A[ J ] := Key
          goto Fin
        end
    
        A[ J ] := A[ I ]
        J := I
      until FALSE

      label Fin
    return 0

    function Restore( F, L ) 
      J  := F
      L2 := L / 2
      while J <= L2 do
        J2 := J + J
    
        if ( J2 < L ) and ( A[ J2 ] < A[ J2 + 1 ] ) then
          M := J2 + 1
        else
          M := J2
        end
    
        if A[ M ] < A[ J ] then
          J := L
        else
    
          temp   << A[ M ]
          A[ M ] << A[ J ]
          A[ J ] << temp
    
          J := M
        end
      end
    return 0

    function Pop( var Key ) 
      Key := A[ 1 ]
      A[ 1 ] := A[ Count ]
      Dec( Count )
      Restore( 1, Count )
    return 0

    function Sort() 
      for J:=2 to Count do
        I := Count - J + 2 
    
        temp   << A[ 1 ]
        A[ 1 ] << A[ I ]
        A[ I ] << temp

        Restore( 1, I - 1 )
    
      end
    return 0

    function ReBuild() 
      N := Count / 2 
      for J:=1 to N do
        I := N - J + 1     
        Restore( I, Count )
      end 
    return 0

    function Print()
      writeln( Count )
      for I:=1 to Count do
        writeln( A[ I ] )
      end 
    return 0 

    function Empty() 
    return Count = 0

    function GetCount() inline
    return Count

  end 

  implementation Queue

    local Head, Tail, Count

    function Push( X )
      if Null( Head ) then
        Head := array( 2 )
        Head[ 1 ] << X
        Tail == Head[ 2 ]

        Count := 1
      else
        Tail := array( 2 )
        Tail[ 1 ] << X 
        Tail == Tail[ 2 ]

        Inc( Count ) 
      end
    return 0

    function Pop( var X )
       Dec( Count )

       Destroy( @X ) 
       X << Head[ 1 ]
       P << Head[ 2 ]
       Destroy( Head )
       Head << P
       if Count = 0 then            
         Destroy( Tail )
       end
    return 0

    function Empty()
    return Null( Head )

    function GetCount() inline
    return Count
  end

  
  implementation Collection

    local K, D

    function InitColl()
      D := 10
      array.Init( D )
      K := 0
    return 0

    function App( X )
      A == Self()
      if K = Card( A ) then
        temp := A
        array.Init( K + D )
        for I:=1 to K do
          A[ I ] == temp[ I ]
        end 
      end  
      K := K + 1
      A[ K ] == X   
    return 0

    function AppColl( iColl )
      object &Coll : Collection
      Coll == iColl
      for I:=1 to Coll.GetCount() do
        App( Coll[ I ] )
      end
    return 0 

    function Print()
      writeln( STR( K ) + ' ' + STR( Self() ) )
    return 0

    function GetCount() inline
    return K

    function "+"( var X, var Y ) 
      K1 := X.GetCount()
      K2 := Y.GetCount()
      D  := 10
      K  := K1 + K2
      A == Self()
      array.Init( K )
      for I:=1 to K1 do
        A[ I ] == X[ I ]
      end
      for I:=1 to K2 do 
        A[ K1 + I ] == Y[ I ]
      end
    return 0
  end

return
