library virtplug;

uses SysUtils;

const
  LibName = 'virtcomp.dll';

function  VirtPopVar : Variant; external LibName name 'VIRTPOPVAR';
procedure VirtPushVar( const V : Variant ); external LibName name 'VIRTPUSHVAR';
function  VirtPopIDOfVariable : Integer; external LibName name 'VIRTPOPIDOFVARIABLE';
procedure VirtPutVar( ID : Integer; const V : Variant ); external LibName name 'VIRTPUTVAR';

procedure _GetCurrentDate;
var
  D : double;
  Year, Month, Day : Word;
  I_Day, I_Month, I_Year : Word;
begin
  I_Day   := VirtPopIDOfVariable;
  I_Month := VirtPopIDOfVariable;
  I_Year  := VirtPopIDOfVariable;

  D := Now;

  DecodeDate( D, Year, Month, Day );

  VirtPutVar( I_Day,   Day );
  VirtPutVar( I_Month, Month );
  VirtPutVar( I_Year,  Year );

  VirtPushVar( 0 );
end;

procedure _GetCurrentTime;
var
  D : double;
  Hour, Min, Sec, MSec : Word;
  I_Hour, I_Min, I_Sec, I_MSec : Word;
begin
  I_MSec  := VirtPopIDOfVariable;
  I_Sec   := VirtPopIDOfVariable;
  I_Min   := VirtPopIDOfVariable;
  I_Hour  := VirtPopIDOfVariable;

  D := Now;

  DecodeTime( D, Hour, Min, Sec, MSec );

  VirtPutVar( I_Hour, Hour );
  VirtPutVar( I_Min,  Min );
  VirtPutVar( I_Sec,  Sec );
  VirtPutVar( I_MSec, MSec );

  VirtPushVar( 0 );
end;


exports

_GetCurrentDate name 'GETCURRENTDATE',
_GetCurrentTime name 'GETCURRENTTIME';

begin
end.
